#!/usr/bin/perl

eval 'exec /usr/bin/perl  -S $0 ${1+"$@"}'
    if 0; # not running under some shell

use strict;
use warnings;

my $MAX_POP = $ENV{MAX_POP} || 64;

my @file_score = glob ('*.yml.score');

my $lookup = {};
my $seen = {};
my $fails = {};

# read all yml.score files, delete any with duplicate values build a lookup table for the rest
for my $file_score (@file_score)
{
    my $stub = $file_score;
    $stub =~ s/\.score$//;
    open FILE, "<". $file_score;
    my @lines = <FILE>;
    close FILE;
    my $score = shift @lines;

    open FILE, "<". $stub .'.fails';
    my @fails = <FILE>;
    close FILE;

    if (defined $seen->{$score})
    {
        unlink $stub;
        unlink $stub .'.score';
        unlink $stub .'.fails';
        unlink $stub .'.svg';
        unlink $stub .'.png';
        unlink $stub .'.net.dot.png';
        unlink $stub .'.tree.dot.png';
        unlink $stub .'.net.dot.svg';
        unlink $stub .'.tree.dot.svg';
        print 'Removed duplicate: '. $stub ."\n";
    }
    else
    {
        $lookup->{$stub} = $score;
        $fails->{scalar @fails}->{$stub} = $score;
        $seen->{$score} = 1;
    }
}

my ($A, $B, $C, $D) = sort {$a <=> $b} keys %{$fails};
# build lists of the best candidates from the first four levels of failure
my @A = sort {$fails->{$A}->{$b} <=> $fails->{$A}->{$a}} keys %{$fails->{$A}};
my @B = sort {$fails->{$B}->{$b} <=> $fails->{$B}->{$a}} keys %{$fails->{$B}};
my @C = sort {$fails->{$C}->{$b} <=> $fails->{$C}->{$a}} keys %{$fails->{$C}};
my @D = sort {$fails->{$D}->{$b} <=> $fails->{$D}->{$a}} keys %{$fails->{$D}};

# up to 1/4 reprieved population can be from second level of failure
@B = splice (@B, 0, int ($MAX_POP/4));
# up to 1/8 of reprieved population can be from third level of failure
@C = splice (@C, 0, int ($MAX_POP/8));
# up to 1/8 of reprieved population can be from fourth level of failure
@D = splice (@D, 0, int ($MAX_POP/8));

# make up rest of reprieved population from first level of failure
@A = splice (@A, 0, $MAX_POP - (scalar @B) - (scalar @C) - (scalar @D));

for my $stub (keys %{$lookup})
{
    if (grep /^$stub$/, @A, @B, @C, @D)
    {
        print 'Kept: '. $stub .' '. $lookup->{$stub};
        next;
    }
    unlink $stub;
    unlink $stub .'.score';
    unlink $stub .'.fails';
    unlink $stub .'.svg';
    unlink $stub .'.png';
    unlink $stub .'.net.dot.png';
    unlink $stub .'.tree.dot.png';
    unlink $stub .'.net.dot.svg';
    unlink $stub .'.tree.dot.svg';
    print 'Croaked: '. $stub .' '. $lookup->{$stub};
}

exit 0;
